if ( !isFile( "base/client/ui/cache/segoe ui_20.ft" ) )
{
	fileCopy( "./res/segoe ui_20.gft", "base/client/ui/cache/segoe ui_20.ft" );
}

package avail_package
{
	function canvas::pushDialog( %this, %ctrl )
	{
		parent::pushDialog( %this, %ctrl );

		if ( isObject( "avGUI" ) && avGUI.isAwake() )
		{
			%this.pushToBack( avGUI );
		}
	}
};

activatePackage( "avail_package" );

// Yeah, need to find a better way of doing this global keybind mapping.
globalActionMap.bind( "keyboard", "ctrl space", "av_toggle" );
moveMap.bind( "keyboard", "ctrl space", "av_toggle" );

function av_toggle( %val )
{
	if ( !%val )
	{
		return;
	}

	%gui = av_getGUI();
	%bse = av_getBSE();
	%res = getRes();
	%spd = 24;

	if ( !%gui.isAwake() )
	{
		canvas.pushDialog( %gui );
		%bse.position = getWord( %res, 0 ) / 2 - 320 SPC -480;
		%bse.pullDownTick( -480, getWord( %res, 1 ) / 2 - 240, %spd );
	}
	else if ( isEventPending( %bse.pushUpTick ) )
	{
		cancel( %bse.pushUpTick );
		%bse.pullDownTick( getWord( %bse.getPosition(), 1 ), getWord( %res, 1 ) / 2 - 240, %spd );
	}
	else if ( isEventPending( %bse.pullDownTick ) )
	{
		cancel( %bse.pullDownTick );
		%bse.pushUpTick( getWord( %bse.getPosition(), 1 ), -480, %spd );
	}
	else if ( %gui.isAwake() )
	{
		%bse.pushUpTick( getWord( %bse.getPosition(), 1 ), -480, %spd );
	}
}

function av_createGUI()
{
	if ( !isObject( %gui = nameToID( "avGUI" ) ) )
	{
		%gui = new guiControl( "avGUI" )
		{
			position = "0 0";
			extent = "640 480";
			visible = true;
		};
	}

	if ( !isObject( %bse = nameToID( "avBSE" ) ) )
	{
		%gui.add( %bse = new guiBitmapCtrl( "avBSE" )
		{
			position = getWord( getRes(), 0 ) / 2 - 320 SPC -480;
			extent = "640 480";
			visible = true;
			bitmap = "./res/frame";
		} );
	}

	if ( !isObject( %prs = nameToID( "avPRS" ) ) )
	{
		%bse.add( %prs = new guiSwatchCtrl( "avPRS" )
		{
			position = "24 24";
			extent = "592 432";
			visible = true;
			color = "0 0 0 255";
		} );
	}

	if ( !isObject( %prs = nameToID( "avPRS" ) ) )
	{
		%bse.add( %prs = new guiSwatchCtrl( "avPRS" )
		{
			position = "24 24";
			extent = "592 432";
			visible = true;
			color = "0 0 0 255";
		} );
	}

	if ( !isObject( %cnt = nameToID( "avCNT" ) ) )
	{
		%prs.add( %cnt = new guiSwatchCtrl( "avCNT" )
		{
			position = "0 0";
			extent = "592 432";
			visible = true;
			color = "0 0 0 0";
		} );
	}

	if ( !isObject( %kbi = nameToID( "avKBI" ) ) )
	{
		%bse.add( %kbi = new guiInputCtrl( "avKBI" )
		{
			position = "0 0";
			extent = "592 432";
			color = "0 0 0 0";
		} );
	}

	if ( !isObject( %mbi = nameToID( "avMBI" ) ) )
	{
		%bse.add( %mbi = new guiMouseEventCtrl( "avMBI" )
		{
			position = "0 0";
			extent = "592 432";
			color = "0 0 0 0";
		} );
	}

	%prs.bringToFront( %cnt );
	%prs.bringToFront( %kbi );
	%prs.bringToFront( %mbi );
}

function av_getGUI()
{
	av_createGUI();
	return nameToID( "avGUI" );
}

function av_getBSE()
{
	av_createGUI();
	return nameToID( "avBSE" );
}

function av_getCNT()
{
	av_createGUI();
	return nameToID( "avCNT" );
}

function avBSE::pushUpTick( %this, %curr, %targ, %spd )
{
	cancel( %this.pushUpTick );

	if ( isEventPending( %this.pullDownTick ) )
	{
		return;
	}

	%x = getWord( %this.getPosition(), 0 );

	if ( %curr <= %targ )
	{
		%this.position = %x SPC %targ;
		canvas.popDialog( av_getGUI() );

		return;
	}

	%curr -= %spd;
	%this.position = %x SPC %curr;
	%this.pushUpTick = %this.schedule( 16, "pushUpTick", %curr, %targ, %spd );
}

function avBSE::pullDownTick( %this, %curr, %targ, %spd )
{
	cancel( %this.pullDownTick );

	if ( isEventPending( %this.pushUpTick ) )
	{
		return;
	}

	%x = getWord( %this.getPosition(), 0 );

	if ( %curr >= %targ )
	{
		%this.position = %x SPC %targ;

		if ( isObject( "avPRS" ) )
		{
			avPRS.fadeInTick( getWord( avPRS.color, 0 ), 255, 8 );
		}

		return;
	}

	%curr += %spd;
	%this.position = %x SPC %curr;
	%this.pullDownTick = %this.schedule( 16, "pullDownTick", %curr, %targ, %spd );
}

function avPRS::fadeInTick( %this, %curr, %targ, %spd )
{
	cancel( %this.fadeInTick );

	if ( isEventPending( avBSE.pushUpTick ) || isEventPending( avBSE.pullDownTick ) )
	{
		return;
	}

	if ( %curr >= %targ )
	{
		%this.color = %targ SPC %targ SPC %targ SPC 255;
		av_loadApps();

		return;
	}

	%curr += %spd;

	if ( %curr > 255 )
	{
		%curr = 255;
	}

	%this.color = %curr SPC %curr SPC %curr SPC 255;
	%this.fadeInTick = %this.schedule( 16, "fadeInTick", %curr, %targ, %spd );
}

function av_loadApps()
{
	if ( !isObject( %cnt = av_getCNT() ) )
	{
		return;
	}

	%cnt.setLoadState( false );

	if ( isObject( %obj = %cnt.appContainer ) )
	{
		%obj.delete();
	}

	%cnt.add( %obj = %appContainer = new guiSwatchCtrl( "avAppContainer" )
	{
		position = "0 0";
		extent = "592 432";
		color = "0 0 0 0";
		visible = false;
	} );

	%cnt.pushToBack( %obj );
	%pattern = "config/apps/*/.app";
	
	for ( %file = findFirstFile( %pattern ) ; %file !$= "" ; %file = findNextFile( %pattern ) )
	{
		%list = %file @ ( strLen( %list ) ? "\t" : "" ) @ %list;
	}

	%pattern = "Add-Ons/System_Avail/apps/*/.app";
	
	for ( %file = findFirstFile( %pattern ) ; %file !$= "" ; %file = findNextFile( %pattern ) )
	{
		%list = %file @ ( strLen( %list ) ? "\t" : "" ) @ %list;
	}

	%count = getFieldCount( %list );

	for ( %i = 0 ; %i < %count ; %i++ )
	{
		if ( !strLen( %file = getField( %list, %i ) ) )
		{
			continue;
		}

		%app = getSubStr( filePath( %file ), 12, strLen( %file ) );
		%pth = filePath( %file );

		%fo = new fileObject();
		%fo.openForRead( %file );

		while ( !%fo.isEOF() )
		{
			%line = %fo.readLine();
			%pos = strPos( %line, ": " );

			if ( %pos < 0 )
			{
				continue;
			}

			%var = getSubStr( %line, 0, %pos );
			%val = getSubStr( %line, %pos + 2, strLen( %line ) );
			%value[ %var ] = strReplace( %val, "<PATH>", %pth );
		}

		%fo.close();
		%fo.delete();

		if ( !strLen( %value[ "name" ] ) )
		{
			warn( %app SPC "- no application name!" );
			continue;
		}

		if ( !isFile( %icon = ( strLen( %value[ %icon ] ) ? %value[ "icon" ] : %pth @ "/icon.png" ) ) )
		{
			%icon = "Add-Ons/System_Avail/res/app_unknown";
		}

		%obj.add( %dfn = new guiSwatchCtrl()
		{
			position = av_getAppPos( %i );
			extent = "96 88";
			visible = true;
			color = "0 0 0 0";
		} );

		%dfn.add( %img = new guiBitmapCtrl()
		{
			position = "16 0";
			extent = "64 64";
			visible = true;
			bitmap = %icon;
		} );

		%dfn.add( %nam = new guiMLTextCtrl()
		{
			position = "0 64";
			extent = "96 24";
			visible = true;
			text = "<just:center><font:segoe ui:20>" @ %value[ "name" ];
		} );
	}

	%obj.setVisible( true );
}

function av_getAppPos( %index )
{
	%x = 12;
	%y = 24;

	%column = mFloor( %index / 4 );
	%row = %index - mFloor( %index / 4 ) * 4;

	%x += %column * 100;
	%y += %row * 100;

	return %x SPC %y;
}

function avCNT::setLoadState( %this, %state )
{
	if ( %state && !isObject( "av_loadSpinner" ) )
	{
		%this.add( new guiAnimatedBitmapCtrl( "av_loadSpinner" )
		{
			position = "288 208";
			extent = "16 16";
			bitmap = "./res/load";

			numFrames = 8;
			framesPerSecond = 20;
		} );
	}

	if ( !%state && isObject( "av_loadSpinner" ) )
	{
		av_loadSpinner.delete();
	}
}